Menu       = require './menu'
menu       = new Menu()

co         = require 'co'
_          = require 'lodash'

Parser     = require './parser'
parser     = new Parser()

Methods    = require './methods'
methods    = new Methods

path       = require 'path'

Config     = require './config'
config     = new Config

Helpers    = require './helpers'
helpers    = new Helpers()


class Converter

  build : co.wrap () ->
    
    configFile = methods.buildPath "config.yaml"
    
    conf = config.loadConfig configFile
    
    contentPath  = methods.buildPath conf.content_dir    
    menuFile     = methods.buildPath "menu.yaml"
    
    menuItems     = yield menu.getMenu contentPath,menuFile
    
    buildDir      = "#{conf.public_dir}/#{conf.output_dir}"
    
    helpersPath      = methods.buildPath conf.helpers_dir
    
    helpersList      = helpers.loadHelpers helpersPath
    
    
    assetsPath      = methods.buildPath("themes/#{conf.theme}/public")
    assetsToPath    = methods.buildPath(conf.public_dir)
    
    
    yield methods.ncp assetsPath,assetsToPath
    
    yield methods.mkdirp buildDir
        
    contentFiles  = []
    
    _.map menuItems, (item,key) ->
      _.map item.childs ,(childs) ->
        contentFiles.push({childs:childs,parent:key})
    
    
    if _.size(contentFiles) is 0
      throw "Unable to find any .md files , make sure you write one"
      
    
    processDocs = yield _.map contentFiles, (file) ->
      
      if file.parent isnt 'welcome'
        
        buildFilePath = path.join methods.basePath,"#{buildDir}/#{file.parent}"
        contentFile = path.join contentPath,"/#{file.parent}/#{file.childs.file}.md"
        
        yield methods.mkdirp buildFilePath
      else
        buildFilePath = path.join methods.basePath,"#{buildDir}" 
        contentFile = path.join contentPath,"#{file.childs.file}.md"
        
      buildFile = "#{buildFilePath}/#{file.childs.slug}.html"
      
      fileContent = yield parser.buildHtml(contentFile,menuItems,conf,helpersList)
      
      try 
        yield methods.writeFile buildFile,fileContent
        return "Done"
      catch e
        throw e
    
    if _.isArray processDocs then return processDocs[0]


module.exports = Converter