
path        = require 'path'
Methods     = require './methods'
methods     = new Methods
_           = require 'lodash'
yaml        = require 'yamljs'
slug        = require 'slug'
extend      = require 'extend'
slugToTitle = require 'slug-to-title'

###*
 * Singleton Menu class , as there is no way
 * to change templates on runtime.
###

class Menu 

  ###*
   * private var to make sure we are not re-initiating
   * the same class.
   * @type {[Object]} [defaults to null]
  ###
  instance = null

  constructor: () ->
    ###*
     * Setting up instance and menu 
     * only when they are not set
    ###
    if !instance
      instance = this
      @menu = {}
    return instance

  
  pathsToObject : (array,output,parent) ->
    self = @
    parent ?= 'welcome'

    _.map array, (val,key) ->
      if val["-type"] is '-'
        key = key.replace /.md|.markdown/ ,''
        if not output[parent]
          output[parent] =
            name   : parent
            childs : {}

        output[parent].childs[key] =
          name : slugToTitle key
          slug : slug key
          file : key

      else if val["-type"] is 'd'
        self.pathsToObject val,output,key
      

  buildMenu : (contentPath) =>
  
    contentPath  = path.resolve contentPath
    try
      contentFiles = yield methods.recursiveDir contentPath
    catch e
      throw "Unable to find content directory"
    data = {}
    @pathsToObject contentFiles,data
    return data

  loadMenu : (contentPath,menuFile) ->

    try
      menu          = yaml.load menuFile
      @menu         = yield @buildMenu contentPath
      extend true,@menu,menu
    catch e
      @menu = yield @buildMenu(contentPath)


  getMenu : (contentPath,menuFile) ->
    ###*
     * Return config if already there
     * or yield it
    ###
    if _.size @menu
      return @menu
    else
      @menu = @loadMenu contentPath,menuFile

module.exports = Menu