chai      = require 'chai'
should    = chai.should()
expect    = chai.expect
assert    = chai.assert
mkdirp    = require 'mkdirp'
co        = require 'co'
async     = require 'async'

Menu    = require '../lib/menu'
menu    = new Menu

fs        = require 'fs'
exec      = require('child_process').exec

menuData = """
introduction:
  name: 'Intro'
"""


describe "Menu", () ->
  
  afterEach (done) ->
    exec 'rm -rf ./tmp', () ->
      done()
  
  describe "loadMenu" , () ->
    
    writeFile = (file,cb) ->
      fs.writeFile file,"",cb

    beforeEach (done) ->
      mkdirp 'tmp/content/introduction', (err) ->
        async.map ['tmp/content/index.md','tmp/content/default.md','tmp/content/introduction/basic usage.md'],writeFile, () ->
          fs.writeFile 'tmp/menu.yaml',menuData,() ->
            done()

    it "should load content from content directory and build menu" , () ->
      
      files = co.wrap () ->
        menu.loadMenu "./tmp/content"

      files()
      .then (success) ->
        expect(success).to.be.an "object"
        expect(success).to.have.property "introduction"
        expect(success.introduction).to.have.property "name"
        expect(success.introduction.name).to.equal "introduction"
        
        expect(success).to.have.property "welcome"
        expect(success.welcome).to.have.property "name"
        expect(success.welcome.name).to.equal "welcome"

        expect(success.welcome).to.have.property "childs"
        expect(success.welcome.childs).to.have.property "index"
        expect(success.welcome.childs.index).to.have.property "name"
        expect(success.welcome.childs.index.name).to.equal "Index"

    it "should load content from content directory and extend menu.yaml file to build menu" , () ->
      
      files = co.wrap () ->
        menu.loadMenu "./tmp/content","tmp/menu.yaml"

      files()
      .then (success) ->
        expect(success).to.be.an "object"
        expect(success).to.have.property "introduction"
        expect(success.introduction).to.have.property "name"
        expect(success.introduction.name).to.equal "Intro"
