chai      = require 'chai'
should    = chai.should()
expect    = chai.expect
assert    = chai.assert
co        = require 'co'

Parser    = require '../lib/parser'
parser    = new Parser

markDownText = "## This is a heading"

markDownTextWithMeta = """
---
title    : Introduction to inker
template : default
----

## This is a heading
"""

describe "Parser", () ->
  
  describe "__extractMetaContent", () ->
    
    it "should return error when no arguments have been passed" , (done) ->
      
      try
        [meta,content] = parser.__extractMetaContent()
      catch e
        expect(e).to.equal("valid markdown text missing")
        done()
        

    it "should return empty object when there is no meta data" , () ->

      [meta,content] = parser.__extractMetaContent(markDownText)
      expect(meta).to.be.an("object")
      expect(Object.keys(meta)).to.have.length 0

    it "should return valid meta object when markdown text has meta data" , () ->

      [meta,content] = parser.__extractMetaContent(markDownTextWithMeta)
      expect(meta).to.be.an("object")
      expect(meta).to.have.property("title").with.equal("Introduction to inker")
      expect(meta).to.have.property("template").with.equal("default")
      
